; This program tries to change the prod name of an AMS 2.03
; TI-89 from "Advanced Mathematics Software" to "Advanced
; Mathematics".  It works under VTI but not on my HW2 calc.
; Instead, it gets into an infinite loop waiting for the
; flash mem to receive it's signal (which is blocked by the
; flash protection).  

		NOLIST
		include		"doorsos.h"
		LIST

		xdef		_ti89
		xdef		_main

; Note: I know that I should erase archive mem before I write
; if I want to change bits w/ 0s to 1s.  But because I am
; only writing 0s, I do not do this.


_main: ;bra _main	; uncomment to help debug under VTI

; Disable ints
DisableInts:
		move.w		#$0700,d0
		trap		#1
		move.l		d0,OldInts

; Install new vector
InstallNewVector:
		move.l		$AC,OldVector
		lea		NewVector,a0
		bclr		#2,$600001
		move.l		a0,$AC		; trap #$B vector
		bset		#2,$600001

; Disable write protection
DisableProtect:
		move.l		$1C5E00,Saved
		lea		Saved,a0
		lea		$1C5E00,a4
		jsr		$2128AE
; Address $2128AE writes a0 to a4 and then does trap #$B

; Change flash ROM
		clr.w		d0
		lea		$21202A,a0
		bsr		write

; Enable write protection
EnableProtect:
		lea		$1C5E00,a0
		lea		Saved,a4
		jsr		$2128AE
; Address $2128AE writes a0 to a4 and then does trap #$B

; Restore vector
RestoreVector:
		bclr		#2,$600001
		move.l 		OldVector,$AC	; trap #$B vector
		bset		#2,$600001

; Enable ints
EnableInts:
		move.l		OldInts,d0
		trap		#1

		rts

; -------------------- Write d0.b to (a0) -----------------
write:
		movem.l		d0-d7/a0-a6,-(a7)
		move.w		#$5050,(a0)		; Clear Status Register
		move.w		#$1010,(a0)		; Write mode
		move.w		d0,(a0)			; Write word
\write_state_busy:
		move.w		(a0),d0			; Read Status Register
		btst		#7,d0			; 1=Ready
		beq		\write_state_busy
		move.w		#$FFFF,(a0)		; Read mode
		movem.l		(a7)+,d0-d7/a0-a6
		rts

; -------------------- New Vector Routine -----------------
NewVector:
		addq.l		#6,a7			; restore stack
		andi		#%1101111111111111,SR	; user mode
		rts

NewVector_End


; ----------------------- ROM routine ---------------------
; address $2128AE
;		ori.b		#$27,d0
;		lsr.l		#6,d2
;		ori.b		#$56,d0
;		ori.b		#$E7
;		move.b		-(a0),-(a4)
;		movea.l		$8(a6),a2
;		move.l		$C(a6),d4
;		moveq		#$2,d3
;		trap		#$B

; ------------------------- Data --------------------------

OldInts:	dc.l		0

OldVector:	dc.l		0

Saved:		dc.b		0

		end